#include <iostream>

using namespace std;

int main()
{
    int N,O,A,B,AB;
    //Grupa A moze da bira samo od A i od O
    //Grupa B moze da bira samo od B i od O
    //Grupa O moze da bira samo od O
    cin >> N;
    cin>>O>>A>>B>>AB;
    string krvnagrupa;
    bool moguce = false;
    bool moguce1 = false;
    bool moguce2 = false;
    bool moguce3 = false;
    bool moguce4 = false;
    int brojpotrebnih;
    int a[N];
    for(int i =0;i<N;i++){
        cin>>krvnagrupa>>brojpotrebnih;
        a[i] = brojpotrebnih;
        if(krvnagrupa == "O"){
            if (O-a[0]>=0){
                moguce = true;
            }else{
                moguce = false;
            }
        }
        if(krvnagrupa == "A"){
            if(A-a[1]>=0){
                moguce1 = true;
            }else if(A+O-a[1]>=0 && A-a[1]<0){
                moguce2 = true;
            }else{
                moguce1 = false;
                moguce2 = false;
            }
        }
        if(krvnagrupa == "B"){
            if(B-a[2]>=0){
                moguce3 = true;
            }else if (B+O-a[2]>=0 && B-a[2]<0){
                moguce4 = true;
            }else{
                moguce3 = false;
                moguce4 = false;
            }
        }


    }
    if(N=3){
    if (moguce == true && moguce1 == true && moguce3 == true || moguce == true && moguce2 == true && moguce3 == true ||moguce == true && moguce1 == true && moguce4 == true || moguce == true && moguce2 == true && moguce4 == true ){
        cout << "moguce"<<endl;
        cout << a[0] << " " << 0 << " " << 0 << " " << 0 << endl;
    }
    if(moguce1 == true && moguce == true && moguce3 ==true|| moguce1 == true && moguce == true && moguce4 == true){
        cout << 0 << " " << a[1] << " " << 0 << " " << 0 << endl;
    }
    if(moguce2 == true && moguce == true && moguce3 == true ||moguce2 == true && moguce == true && moguce4 == true ){
        cout << a[1]-A << " " << A << " " << 0 << " " << 0 << endl;
    }
    if(moguce == false ||(moguce1 == false && moguce2 == false)|| (moguce3 == false && moguce4 == false) && N!=3){
        cout <<"nemoguce";
    }
    if(moguce3 == true && moguce == true && moguce1==true || moguce3 == true && moguce == true && moguce2==true ){
        cout << 0 << " " << 0 << " " << a[2] << " " << 0 << endl;
    }
    if(moguce4 == true && moguce == true && moguce1==true){
        cout << a[2] - B << " " << 0 << " " << B << " " << 0 << endl;
    }
    if(moguce4 == true && moguce == true && moguce2==true){
        cout << a[2] - B << " " << 0 << " " << B << " " << 0;
    }


}
}